#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
const ll MOD = 1e9+7;
const int N = 1e6+5;

int n,a[N],c[10];

int main()
{
    ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);
    cin>>n;
    for(int i=1;i<=n;i++){
        cin>>a[i];
    }
    pair<int,int>p={-1,-1};

    for(int i=n;i>=1;i--){
        for(int j=a[i]+1;j<=9;j++){
            if(c[j]){
                p={i,c[j]};
            }
        }
        if(!c[a[i]])c[a[i]]=i;
    }

    if(p.first==-1){
        p.first=n-1;
        p.second=n;
    }

    swap(a[p.first],a[p.second]);
    for(int i=1;i<=n;i++)cout<<a[i]<<" ";

    return 0;
}